% This code has been taken from website www.mathworks.com, and was
% modified by myself, by changing something or by adding some features.


% Info on the author of the code taken from www.mathworks.com:

% Author: Joseph Kirk
% Email: jdkirk630 at gmail dot com
% Release: 1.3
% Release Date: 5/18/07


% License present on the code taken from www.mathworks.com:

% Copyright (c) 2006, Joseph Kirk
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are
% met:
% 
%     * Redistributions of source code must retain the above copyright
%       notice, this list of conditions and the following disclaimer.
%     * Redistributions in binary form must reproduce the above copyright
%       notice, this list of conditions and the following disclaimer in
%       the documentation and/or other materials provided with the distribution
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
% POSSIBILITY OF SUCH DAMAGE.


function [dist,path] = dijkstra_intermediate_nodes(i,UPW_int_nodes_matrix,RET_int_nodes_matrix,SID,FID,nodes,edges)

% initialize data
dist_parz = 0;
path_parz = 0;
dist = 0;
path = 0;

% UPWARD TRIP 

% 1) From SID to Intermediate Node 1 - ALWAYS EXECUTED
[dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,SID,UPW_int_nodes_matrix(i,1));

path = path_parz;
path(end) = []; %delete last element of path vector (since it will be found in next search)
dist = dist + dist_parz;


nint = nnz(UPW_int_nodes_matrix(i,:)); %count the number of intermediate nodes to be crossed


% 2) Eventual MID step - NOT ALWAYS EXECUTED
if nint > 1 %if more than a single intermediate node --> execute MID step (movement b/w couples of int nodes)
    
    for j = 1:nint-1
        
        [dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,UPW_int_nodes_matrix(i,j),UPW_int_nodes_matrix(i,j+1));

        path = [ path path_parz ];
        path(end) = [];
        dist = dist + dist_parz;
        
    end
    
end


% 3) From Last Intermediate to FID - ALWAYS EXECUTED
[dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,UPW_int_nodes_matrix(i,nint),FID);

path = [ path path_parz ];
path(end) = [];
dist = dist + dist_parz;


%
%
%
% RETURN TRIP 

% 1) From FID to Intermediate Node 1 - ALWAYS EXECUTED
[dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,FID,RET_int_nodes_matrix(i,1));

path = [ path path_parz ];
path(end) = []; %delete last element of path vector (since it will be found in next search)
dist = dist + dist_parz;


nint = nnz(RET_int_nodes_matrix(i,:)); %count the number of intermediate nodes to be crossed


% 2) Eventual MID step - NOT ALWAYS EXECUTED
if nint > 1 %if more than a single intermediate node --> execute MID step (movement b/w couples of int nodes)
    
    for j = 1:nint-1
        
        [dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,RET_int_nodes_matrix(i,j),RET_int_nodes_matrix(i,j+1));

        path = [ path path_parz ];
        path(end) = [];
        dist = dist + dist_parz;
        
    end
    
end


% 3) From Last Intermediate to SID - ALWAYS EXECUTED
[dist_parz,path_parz] = dijkstra_algorithm(nodes,edges,RET_int_nodes_matrix(i,nint),SID);

path = [ path path_parz ];
dist = dist + dist_parz;



end

