% This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 
% International License. To view a copy of this license, visit 
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to 
% Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.

function [Nodes_Neighbors_D5_Ver] = find_D5_vertical_neighbors(nodes,segments,corr_v)

%initialize variables
num_nodes = size(nodes,1);
Nodes_Neighbors_5_Ver = zeros(num_nodes,10); %a VER node has maximum 10 vert neighbors in a radius of 5
Nodes_Neighbors_D5_Ver = zeros(num_nodes,2); %a VER node has maximum 2 vert neighbors at a distance of 5

s = segments(:,2);
t = segments(:,3);

G = graph(s,t);

for i=1:num_nodes %scroll nodes
    ktot = 0; %counter of found neighbors
    partial_neigh = 0;
    node = nodes(i,1); %node under analysis
    if corr_v(i) ~= 0 % if node is vertical (possibly)
        corr = corr_v(i);
        N = neighbors(G,i); %find all its neighbors
        
        for n = 1:size(N,1)
            if ((corr_v(N(n))~= 0) && (corr_v(N(n)) == corr)) % if belongs to the same ver corridor
                ktot = ktot + 1;
                partial_neigh(ktot,1) = N(n);
                Nodes_Neighbors_5_Ver(i,ktot) = N(n);
            end
        end
              
        %first neighbor searching cycle ended 
        
        
        iter = 0;
        
        for cycle = 1:4 %repeat searching procedure 4 times, to be able to find D5 neighbors
            partial_neigh_fixed = Nodes_Neighbors_5_Ver(i,:); %save a copy of neighbors found up to now
        
            for j=1:size(partial_neigh_fixed,2) %cycle each neighbor, for every loop at increasing distance
                if partial_neigh_fixed(j) ~= 0
                    node1 = partial_neigh_fixed(j); %node under analysis
                    N = neighbors(G,node1); %find all its neighbors

                    for n = 1:size(N,1) %cycle all neighbors
                        if (((corr_v(N(n))~= 0) && (nodes(N(n),1) ~= node))  && (corr_v(N(n)) == corr)) %if belongs to the same ver corridor
                            already_present = 0;
                            for ii=1:size(partial_neigh_fixed,2) %check if node is already present in neighbor matrix
                                if partial_neigh_fixed(ii) == N(n) %if already present
                                    already_present = 1;
                                end
                            end

                            if already_present == 0 %if NOT already present
                                %update matrix
                                ktot = ktot + 1;
                                Nodes_Neighbors_5_Ver(i,ktot) = N(n);
                            end
                            
                            if (already_present == 0) && (cycle == 4) %if not already present AND at a distance of 5
                                % update matrix
                                iter = iter + 1;
                                Nodes_Neighbors_D5_Ver(i,iter) = N(n);
                            end
                            
                        end
                    end
                end
            end
        end
    end  
end


end








