% This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 
% International License. To view a copy of this license, visit 
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to 
% Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.

function [Nodes_Neighbors_R2_Hor] = find_R2_horizontal_neighbors(nodes,segments,corr_h)

%initialize variables
num_nodes = size(nodes,1);
Nodes_Neighbors_R2_Hor = zeros(num_nodes,4);

s = segments(:,2);
t = segments(:,3);

G=graph(s,t);


% first neighbor searching cycle

for i=1:num_nodes %scroll nodes
    ktot = 0;
    partial_neigh = 0;
    node = nodes(i,1); %node under analysis
    if corr_h(i) ~= 0 % if belongs to a HOR corridor
        corr = corr_h(i); %save HOR corridor number of that node;
        N = neighbors(G,i); %find all its neighbors
        
        for n = 1:size(N,1) %scroll its neighbors
            if ((corr_h(N(n)) ~= 0) && (corr_h(N(n)) == corr)) % if that neighbor belongs to same Hor corridor
                ktot = ktot + 1; %R2 Hor Neighbor found
                partial_neigh(ktot,1) = N(n);
                Nodes_Neighbors_R2_Hor(i,ktot) = N(n); %add this R2 Hor neighbor to the matrix
            end
        end
        
        %second neighbor searching cycle
        
        partial_neigh_fixed = partial_neigh; %save a fixed copy of partial neigh
        
        for j=1:size(partial_neigh_fixed,1) %cycle each 1st order neighbor
            partial_neigh = 0;
            kparz = 0; %reset partial counter
            N = neighbors(G,partial_neigh_fixed(j)); %find the neighbors of that neighbor
            
            for n = 1:size(N,1) %scroll 2nd cycle neighbors
                if (((corr_h(N(n)) ~= 0) && (nodes(N(n),1) ~= node)) && (corr_h(N(n)) == corr))% if belongs to the same hor corridor
                    already_present = 0; %reset flag
                    for ii=1:size(partial_neigh_fixed,1) %check if node is already present in neighbor matrix
                        if partial_neigh_fixed(ii) == N(n) 
                            already_present = 1; %if already present, set flag to 1
                        end
                    end
                    
                    if already_present == 0 %if NOT already present
                        kparz = kparz + 1; %R2 Hor Neighbor found
                        ktot = ktot + 1;
                        partial_neigh(kparz,1) = N(n);
                        Nodes_Neighbors_R2_Hor(i,ktot) = N(n); %add this R2 Hor neighbor to the matrix
                    end
                end
            end
        end
    end  
end


end








